Subject: Re: FVWM: config question

From: tstout <[email-masked]>
Date: Mon, 8 Sep 2003 08:26:13 -0400 (EDT)

whoa!  thanks for getting back to me so quickly!!  you rock!

anyway, i didn't provide a whole lot of info because i figured this might be a 
fairly common issue, as my installation is all very generic and off-the-shelf.

anyway, the popup is a gnome dialog box.  when i run the program kppp (or any of 
the included redhat config apps) from the command line (so far i've tried it in 
xterm and rxvt), it runs fine.  what happens is that the "executable" is 
actually just linked to a program called 'consolehelper' that checks 
authentication rules through pam, then calls the appropriate program in a 
'semi-sudo' type of context.  arguments are passed transparently, but i don't 
actually RUN the program -- its kinda like a local proxy server of sorts.

so the "new format" just saves me from running a shell process with each 
program.  and that actually makes sense -- now with the 'exec exec kppp', i'm 
not running a shell process, which is why it worked before (when i WAS running a 
shell process with the 'exec kppp').  is there a way to force a shell process on 
a menu item? i'm sure that would solve this...

>Date: Mon, 8 Sep 2003 09:51:47 +0200
>From: Dominik Vogt <[email-masked]>
>To: Tony Stout <[email-masked]>, fvwm <[email-masked]>
>Subject: Re: FVWM: config question
>Mail-Followup-To: Tony Stout <[email-masked]>, fvwm <[email-masked]>
>Mime-Version: 1.0
>Content-Disposition: inline
>User-Agent: Mutt/1.3.28i
>
>On Sun, Sep 07, 2003 at 11:20:25PM -0400, Tony Stout wrote:
>> i just upgraded from fvwm95 (2.0.43d) to the current release of 2.4.15.  
>> i've successfully updated all my configs, and everything seems to be 
>> running nicely.
>> 
>> redhat 8.0 uses the package consolehelper/usermode to route specific 
>> authentication requests through pam.  in 2.0.43 (calling the needed 
>> program with a simple "exec" statement - like 'exec kppp'), the gnome 
>> popup would appear, ask for the root password, accept/deny, and run the 
>> program as appropriate.
>
>> i'm now finding that when i use the new format 
>> ('Exec exec kppp'),
>
>It's not really a new format.  it just saves you running a shell
>process for each application you start this way.  This is achieved
>by the "exec" shell command.
>
>> i get a nifty popup saying "Invalid Call to Subprocess".
>
>Fvwm does not use popup windows, so it must come from your shell
>(highly unlikely) or kppp itself.  Can you identify which program
>opened the popup window?  If not, using FvwmIdent should help.
>
>Check your kppp installation.  Does it work when invoked on the
>command line?  Possibly it expects some environtment variable to
>be set.
>
>> i'm sure this is probably a simple config issue, and although i know i 
>> could modify each entry in the 'menus' config file, i'm hoping there is 
>> a global method to solve this.
>> 
>> btw, i'm running an out-of-the-box version of redhat 8.0.  i downloaded 
>> the source for 2.4.15, compiled it with defaults, and installed.  i 
>> modified/added entries for gdm to call fvwm directly, so i'm not using 
>> any gnome session-management.  ideally, i'd like to keep them as 
>> separate as possible.
>> 
>> any ideas?
>
>Ciao
>
>Dominik ^_^  ^_^

--
Visit the official FVWM web page at <URL: http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: Dominik Vogt <[email-masked]>
Date: Mon, 8 Sep 2003 14:47:22 +0200

> a menu item? i'm sure that would solve this...

Just omit one of the "exec"s.  I know it's a bit confusing:  the
first "exec" (or "Exec") is the fvwm command.  Everything behind
it is passed to the shell:

  Exec exec kppp
  ^^^^ ^^^^^^^^^
   |       |________ command passed to the shell
   |________________ Fvwm command

So your former "exec kppp" should work too:

  exec kppp
  ^^^^ ^^^^
   |    |___________ command passed to the shell
   |________________ Fvwm command

Ciao

Dominik ^_^  ^_^

---

From: Tony Stout <[email-masked]>
Date: Mon, 08 Sep 2003 18:47:46 -0400

>it is passed to the shell:
i tried modifying my config to use "exec kppp", and i get the same gnome 
error as when the line reads "Exec exec kppp".  when i try "kppp" in 
fvwmconsole, i get "[FVWM][execute_function]: <<ERROR>> No such command 
'kppp'" (as expected).  using "exec kppp" in fvwmconsole, i get the 
gnome error (above).  if, however, i use "xterm -e kppp", i get a shell 
and the authentication step proceeds properly.  its almost as if the 
exec statement is not using a shell process at all, but instead calling 
the link directly.

like i said, it worked just fine in 2.0.43.   any ideas?

---

From: Dan Espen <[email-masked]>
Date: Mon, 08 Sep 2003 19:03:48 -0400

> exec statement is not using a shell process at all, but instead calling 

Try using 2.4.16.  There were some changes made to the way Exec works
after 2.4.15.

kppp launches fine for me using the latest CVS.  2.4.16 uses the same
logic as the latest CVS.

If you really can't use 2.4.16 for some reason, try:

Exec bash -c kppp

-- 
Dan Espen                           E-mail: [email-masked]

---

From: Dominik Vogt <[email-masked]>
Date: Tue, 9 Sep 2003 09:49:12 +0200

> > exec statement is not using a shell process at all, but instead calling 

I think at least some modern shells are clever enough to imply
"exec" if they run a program non-interactively (i.e. they
terminate themselves on their own).  If all else fails, writing a
shell script should help.  However, I think this is a bug in the
gnome wrapper you mentioned.  It shouldn't be this picky about how
it is started.

> Try using 2.4.16.  There were some changes made to the way Exec works

I.e. programs invoked with "exec" now run with stdin/stdout
detached.

Ciao

Dominik ^_^  ^_^